summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
Diffstat (limited to 'tests')
-rwxr-xr-xtests/misc/stat-nanoseconds27
-rwxr-xr-xtests/touch/60-seconds2
2 files changed, 19 insertions, 10 deletions
diff --git a/tests/misc/stat-nanoseconds b/tests/misc/stat-nanoseconds
index 314f43e2c..0f41eb045 100755
--- a/tests/misc/stat-nanoseconds
+++ b/tests/misc/stat-nanoseconds
@@ -19,18 +19,27 @@
test "$VERBOSE" = yes && stat --version
. "${srcdir=.}/init.sh"; path_prepend_ ../src
-touch -d '2010-10-21 18:43:33.023456789' k || framework_failure_
+# Set this to avoid problems with weird time zones.
+TZ=UTC0
+export TZ
+
+# Use a time stamp near the Epoch to avoid trouble with leap seconds.
+touch -d '1970-01-01 18:43:33.023456789' k || framework_failure_
ls --full-time | grep 18:43:33.023456789 \
|| skip_ this file system does not support sub-second time stamps
-test "$(stat -c %:X k)" = 023456789 || fail=1
-test "$(stat -c %3:X k)" = 23456789 || fail=1
-test "$(stat -c %3.3:X k)" = 023 || fail=1
-test "$(stat -c %.3:X k)" = 023 || fail=1
-test "$(stat -c %03.3:X k)" = 023 || fail=1
-test "$(stat -c %-5.3:X k)" = '023 ' || fail=1
-test "$(stat -c %05.3:X k)" = ' 023' || fail=1
-test "$(stat -c %010.3:X k)" = ' 023' || fail=1
+test "$(stat -c %X k)" = 67413 || fail=1
+test "$(stat -c %.X k)" = 67413.023456789 || fail=1
+test "$(stat -c %.1X k)" = 67413.0 || fail=1
+test "$(stat -c %.3X k)" = 67413.023 || fail=1
+test "$(stat -c %.6X k)" = 67413.023456 || fail=1
+test "$(stat -c %.9X k)" = 67413.023456789 || fail=1
+test "$(stat -c %13.6X k)" = ' 67413.023456' || fail=1
+test "$(stat -c %013.6X k)" = 067413.023456 || fail=1
+test "$(stat -c %-13.6X k)" = '67413.023456 ' || fail=1
+test "$(stat -c %18.10X k)" = ' 67413.0234567890' || fail=1
+test "$(stat -c %018.10X k)" = 0067413.0234567890 || fail=1
+test "$(stat -c %-18.10X k)" = '67413.0234567890 ' || fail=1
Exit $fail
diff --git a/tests/touch/60-seconds b/tests/touch/60-seconds
index d0082967c..e06c770f2 100755
--- a/tests/touch/60-seconds
+++ b/tests/touch/60-seconds
@@ -30,7 +30,7 @@ echo 60.000000000 > exp || framework_failure
# an `invalid date format'. Specifying 60 seconds *is* valid.
TZ=UTC0 touch -t 197001010000.60 f || fail=1
-stat --p='%Y.%:Y\n' f > out || fail=1
+stat --p='%.9Y\n' f > out || fail=1
compare out exp || fail=1